'''
Created on Jul 24, 2016

@author: breno
'''

import os, subprocess
from random import randint
from cPickle import load

from coverage_info import run_cmd
import cmd

if __name__ == '__main__':
    subject = "grep"
    #versions = ['v1','v2','v4','v5']
    versions = ['v2']
    budget = 50
    
    for version in versions:
        selected = []
        print 'version: {}'.format(version)
        with open(os.path.join("subjects", subject, version, "part_map.pickle"), "r") as _:
            part_map = load(_)
            partitions = part_map.keys()
            
        cmd = "python select.py {} --ver {} --cleanup -d".format(subject, version)
        run_cmd(cmd.split())
        
        iteration = 0
        while len(selected) < budget:
            for partition in range(len(partitions)):
                remaining = budget - len(selected)
                num_tcs = randint(1, min(remaining, len(part_map[partition]), 5))
                #subprocess.call("python select.py grep --ver v3 -c function --fm all -i {} -p {} -n {} -v".format(iteration, partition, num_tcs), shell=True)
                cmd = "python select.py {} --ver {} -c function -i {} -p {} -n {} -v".format(subject, version, iteration, partition, num_tcs)
                _, response = run_cmd(cmd.split())
                selected_i = response[0].replace("\n", "")
                print selected_i
                selected.extend(selected_i.split(","))            
                #print "total", len(selected)
                if len(selected) == budget:
                    break
            iteration += 1
        
        cmd = "python select.py {} --ver {} --cleanup -d".format(subject, version)
        run_cmd(cmd.split())
        
        print "Test suite ({}): {}".format(len(selected), selected)
            
        